package com.loafle.overflow.central.module.probe.service;

import java.util.List;

import com.loafle.overflow.central.module.probe.dao.ProbeHostDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.probe.ProbeHost;
import com.loafle.overflow.service.central.probe.ProbeHostService;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service("ProbeHostService")
public class CentralProbeHostService implements ProbeHostService {

  @Autowired
  private ProbeHostDAO probeHostDAO;

  public ProbeHost regist(ProbeHost probeHost) throws OverflowException {
    return this.probeHostDAO.save(probeHost);
  }

  public ProbeHost read(Long id) throws OverflowException {
    return this.probeHostDAO.findById(id).get();
  }

  public ProbeHost readByProbeID(Long probeID) throws OverflowException {
    return this.probeHostDAO.findByProbeId(probeID);
  }

  public List<ProbeHost> readAllByDomainID(Long domainID) throws OverflowException {
    return this.probeHostDAO.findAllByProbeDomainId(domainID);
  }
}
