package com.loafle.overflow.central.module.sensor.service;

import com.loafle.overflow.central.module.sensor.dao.SensorItemDependencyDAO;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.meta.MetaSensorDisplayItem;
import com.loafle.overflow.model.meta.MetaSensorItemKey;
import com.loafle.overflow.model.sensor.SensorItemDependency;

import com.loafle.overflow.service.central.sensor.SensorItemDependencyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by insanity on 17. 9. 20.
 */

@Service("SensorItemDependencyService")
public class CentralSensorItemDependencyService implements SensorItemDependencyService {

  @Autowired
  private SensorItemDependencyDAO sensorItemDependencyDAO;

  public SensorItemDependency regist(SensorItemDependency dependency) throws OverflowException {
    return this.sensorItemDependencyDAO.save(dependency);
  }

  public List<MetaSensorItemKey> readAllMetaSensorItemKeyByMetaSensorDisplayItemID(Long metaSensorDisplayItemID)
      throws OverflowException {
    return this.sensorItemDependencyDAO.findAllMetaSensorItemKeyByMetaSensorDisplayItemId(metaSensorDisplayItemID);
  }

  public Map<String, List<MetaSensorItemKey>> readAllMapByMetaSensorDisplayItems(
      List<MetaSensorDisplayItem> metaSensorDisplayItems) throws OverflowException {

    Map<String, List<MetaSensorItemKey>> map = new HashMap<String, List<MetaSensorItemKey>>();

    for (MetaSensorDisplayItem displayItem : metaSensorDisplayItems) {
      List<MetaSensorItemKey> itemKeys = this.sensorItemDependencyDAO
          .findAllMetaSensorItemKeyByMetaSensorDisplayItemId(displayItem.getId());
      map.put(displayItem.getKey(), itemKeys);
    }

    return map;
  }
}
